'use strict';

const Promise = require('bluebird');

const Service = require('../service');

class MockApi extends Service {
  constructor(options, context) {
    super(options, context);

    this.methods = {};
  }

  call(methodName, parameters, options) {
    if (!this.methods[methodName]) {
      throw new Error(`Method ${methodName} not found`);
    }

    const result = Promise.try(() => {
      return this.methods[methodName](parameters, options)
    });

    return result.then(result => {
      return {data: result, info: {}};
    });
  }

  on(methodName, method) {
    this.methods[methodName] = method;
  }
}

module.exports = MockApi;
